"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var ValidationContext =
/*#__PURE__*/
function () {
  function ValidationContext(schema) {
    (0, _classCallCheck2["default"])(this, ValidationContext);
    Object.defineProperties(this, {
      schema: {
        enumerable: true,
        configurable: false,
        writable: false,
        value: schema
      },
      _messages: {
        enumerable: false,
        configurable: true,
        writable: true,
        value: {}
      },
      _valid: {
        enumerable: false,
        configurable: true,
        writable: true,
        value: true
      }
    });
  }

  (0, _createClass2["default"])(ValidationContext, [{
    key: "isValid",
    value: function isValid() {
      return this._valid;
    }
  }, {
    key: "getMessages",
    value: function getMessages() {
      return (0, _extends2["default"])({}, this._messages);
    }
  }, {
    key: "getMessage",
    value: function getMessage(field) {
      return this._messages[field];
    }
  }, {
    key: "setMessage",
    value: function setMessage(field, message) {
      if (typeof field !== 'string') {
        throw new TypeError('Invalid field value');
      } else if (!(field.split('.')[0] in this.schema.fields)) {
        throw new Error('Unknown field : ' + field + ' (' + this.schema.fieldNames.join(', ') + ')');
      } else if (message && typeof message !== 'string') {
        throw new TypeError('Invalid message for ' + field);
      } else if (message) {
        this._messages[field] = message;
      } else {
        delete this._messages[field];
      }

      this._valid = !Object.keys(this._messages).length;
    }
  }, {
    key: "reset",
    value: function reset() {
      this._messages = {};
      this._valid = true;
    }
  }, {
    key: "validate",
    value: function validate(data) {
      var _this = this;

      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var _this$schema = this.schema,
          fieldNames = _this$schema.fieldNames,
          fields = _this$schema.fields;
      var validateFieldNames = options.fields,
          _options$validatorOpt = options.validatorOptions,
          validatorOptions = _options$validatorOpt === void 0 ? {} : _options$validatorOpt;

      if ((0, _typeof2["default"])(data) !== 'object') {
        throw new TypeError('Data must be an object');
      } // reset 'notInSchema' errors


      Object.keys(this._messages).forEach(function (fieldName) {
        if (_this._messages[fieldName] === 'notInSchema') {
          delete _this._messages[fieldName];
        }
      }); // set 'notInSchema' errors

      (validateFieldNames || Object.keys(data)).forEach(function (fieldName) {
        if (!(fieldName in fields)) {
          _this._messages[fieldName] = 'notInSchema';
        }
      });
      (validateFieldNames || fieldNames).forEach(function (fieldName) {
        Object.keys(_this._messages).forEach(function (messageKey) {
          if (messageKey.split('.')[0] === fieldName) {
            delete _this._messages[messageKey];
          }
        });
        var field = fields[fieldName];
        var value = data[fieldName];
        var self = {
          fieldName: fieldName,
          options: validatorOptions,
          getField: function getField(fieldName) {
            var path = typeof fieldName === 'string' ? fieldName.split('.') : undefined;
            var value = data;
            var exists = true;

            if (!path) {
              throw new TypeError('Invalid fieldName');
            }

            for (var index = 0, len = path.length; index < len; ++index) {
              if (value && (0, _typeof2["default"])(value) === 'object' && path[index] in value) {
                value = value[path[index]];
              } else {
                value = undefined;
                exists = false;
              }
            }

            return {
              exists: exists,
              value: value
            };
          }
        };
        var result = field.validator(value, self, _this);

        if (result && typeof result === 'string') {
          _this._messages[fieldName] = result;
        }
      });
      return this._valid = !Object.keys(this._messages).length;
    }
  }]);
  return ValidationContext;
}();

var _default = ValidationContext;
exports["default"] = _default;