"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createModel = createModel;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

/**
Create a new model given the specified fields

@param schema {Schema}
@return {Object}
*/
function createModel(schema, data) {
  var fields = schema.fields,
      fieldNames = schema.fieldNames;
  var model = (0, _extends2["default"])({}, data || {});
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = fieldNames[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var fieldName = _step.value;
      var field = fields[fieldName];

      if (!(fieldName in model) && 'defaultValue' in field) {
        model[fieldName] = typeof field.defaultValue === 'function' ? field.defaultValue() : field.defaultValue;
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator["return"] != null) {
        _iterator["return"]();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return model;
}