"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isType = isType;
exports.getType = getType;
exports.TypeProvider = exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _any = _interopRequireDefault(require("./any"));

var _anyOf = _interopRequireDefault(require("./any-of"));

var _array = _interopRequireDefault(require("./array"));

var _arrayOf = _interopRequireDefault(require("./array-of"));

var _boolean = _interopRequireDefault(require("./boolean"));

var _date = _interopRequireDefault(require("./date"));

var _integer = _interopRequireDefault(require("./integer"));

var _number = _interopRequireDefault(require("./number"));

var _object = _interopRequireDefault(require("./object"));

var _string = _interopRequireDefault(require("./string"));

var typeMap = [_any["default"], _array["default"], _boolean["default"], _date["default"], _number["default"], _object["default"], _string["default"]].reduce(function (map, type) {
  map[String(type.$$type).slice(7, -1)] = type;
  map[type.$$primitive] = type;
  return map;
}, {});

function isType(type) {
  return type && (type instanceof TypeProvider || typeMap[type] || type.$$type && !Array.isArray(type.$$type) && typeof type.validatorFactory === 'function') || false;
}

function getType(type) {
  if (type instanceof TypeProvider) {
    type = type.getType();

    if (!isType(type)) {
      throw new TypeError('TypeProvider does not return valid type');
    }

    return type;
  } else if (Array.isArray(type)) {
    if (!type.length) {
      return _array["default"];
    } else if (type.length === 1) {
      return (0, _arrayOf["default"])(typeMap[type[0]]);
    } else {
      return _anyOf["default"].apply(void 0, (0, _toConsumableArray2["default"])(type.map(function (t) {
        return getType(typeMap[t]);
      })));
    }
  } else if (isType(type)) {
    return typeMap[type] || type;
  }
}
/**
 * Implement custom types that can be validated
 */


var TypeProvider =
/*#__PURE__*/
function () {
  function TypeProvider() {
    (0, _classCallCheck2["default"])(this, TypeProvider);

    if (this.__proto__ === TypeProvider.prototype) {
      throw new Error('Cannot directly create instance of TypeProvider');
    }
  }
  /**
   * Return the type of this object
   * @return {type}
   */


  (0, _createClass2["default"])(TypeProvider, [{
    key: "getType",
    value: function getType() {
      throw new Error('Not implemented');
    }
  }]);
  return TypeProvider;
}();

exports.TypeProvider = TypeProvider;
var _default = {
  Any: _any["default"],
  AnyOf: _anyOf["default"],
  Array: _array["default"],
  ArrayOf: _arrayOf["default"],
  Boolean: _boolean["default"],
  Date: _date["default"],
  Integer: _integer["default"],
  Number: _number["default"],
  Object: _object["default"],
  String: _string["default"]
};
exports["default"] = _default;