"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

/**
Object type

Usage:

   {
     a: Object
   }

See schema.js for more information
*/
var _default = Object.freeze({
  $$type: Symbol('object'),
  $$primitive: Object,
  validatorFactory: objectValidator
});

exports["default"] = _default;
var proto = Object.prototype;
var gpo = Object.getPrototypeOf;
/**
Validation function favtory

@param fieldName {String}           the field name being eva
@param field {Object}               the field options
@param schema {Schema}              the schema instance
@param wrappedValidator {Function}  (optional) the validator being wrapped
*/

function objectValidator(fieldName, field, schema, wrappedValidator) {
  var _field$required = field.required,
      required = _field$required === void 0 ? false : _field$required,
      _field$nullable = field.nullable,
      nullable = _field$nullable === void 0 ? true : _field$nullable;
  return function validator(value, self, context) {
    if (value === undefined && required) {
      return 'required';
    } else if (value === null && !nullable) {
      return 'isNull';
    } else if (value !== undefined && value !== null && ((0, _typeof2["default"])(value) !== 'object' || gpo(value) !== proto)) {
      return 'invalidType';
    }

    return wrappedValidator && wrappedValidator(value, self, context);
  };
}