"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _number = _interopRequireDefault(require("./number"));

/**
Integer type

Usage:

   {
     a: SchemaType.Integer
   }

See schema.js for more information
*/
var _default = Object.freeze({
  $$type: Symbol('integer'),
  validatorFactory: integerValidator
});
/**
Validation function favtory

@param fieldName {String}           the field name being eva
@param field {Object}               the field options
@param schema {Schema}              the schema instance
@param wrappedValidator {Function}  (optional) the validator being wrapped
*/


exports["default"] = _default;

function integerValidator(fieldName, field, schema, wrappedValidator) {
  return _number["default"].validatorFactory(fieldName, field, schema, function (value, self, context) {
    if (value) {
      if ((value | 0) !== value || value === -Infinity || value === Infinity) {
        return 'invalidType';
      }
    }

    return wrappedValidator && wrappedValidator(value, self, context);
  });
}