"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

/**
Boolean type

Usage:

   {
     a: Boolean
   }

See schema.js for more information
*/
var _default = Object.freeze({
  $$type: Symbol('boolean'),
  $$primitive: Boolean,
  validatorFactory: booleanValidator
});
/**
Validation function favtory

@param fieldName {String}           the field name being eva
@param field {Object}               the field options
@param schema {Schema}              the schema instance
@param wrappedValidator {Function}  (optional) the validator being wrapped
*/


exports["default"] = _default;

function booleanValidator(fieldName, field, schema, wrappedValidator) {
  var _field$required = field.required,
      required = _field$required === void 0 ? false : _field$required,
      _field$nullable = field.nullable,
      nullable = _field$nullable === void 0 ? true : _field$nullable;
  return function validator(value, self, context) {
    if (value === undefined && required) {
      return 'required';
    } else if (value === null && !nullable) {
      return 'isNull';
    } else if (value !== undefined && value !== null && value !== true && value !== false) {
      return 'invalidType';
    }

    return wrappedValidator && wrappedValidator(value, self, context);
  };
}