(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
	typeof define === 'function' && define.amd ? define(['exports'], factory) :
	(global = global || self, factory(global.Schema = {}));
}(this, function (exports) { 'use strict';

	function createCommonjsModule(fn, module) {
		return module = { exports: {} }, fn(module, module.exports), module.exports;
	}

	var _typeof_1 = createCommonjsModule(function (module) {
	function _typeof2(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof2 = function _typeof2(obj) { return typeof obj; }; } else { _typeof2 = function _typeof2(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof2(obj); }

	function _typeof(obj) {
	  if (typeof Symbol === "function" && _typeof2(Symbol.iterator) === "symbol") {
	    module.exports = _typeof = function _typeof(obj) {
	      return _typeof2(obj);
	    };
	  } else {
	    module.exports = _typeof = function _typeof(obj) {
	      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : _typeof2(obj);
	    };
	  }

	  return _typeof(obj);
	}

	module.exports = _typeof;
	});

	function _classCallCheck(instance, Constructor) {
	  if (!(instance instanceof Constructor)) {
	    throw new TypeError("Cannot call a class as a function");
	  }
	}

	var classCallCheck = _classCallCheck;

	function _assertThisInitialized(self) {
	  if (self === void 0) {
	    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
	  }

	  return self;
	}

	var assertThisInitialized = _assertThisInitialized;

	function _possibleConstructorReturn(self, call) {
	  if (call && (_typeof_1(call) === "object" || typeof call === "function")) {
	    return call;
	  }

	  return assertThisInitialized(self);
	}

	var possibleConstructorReturn = _possibleConstructorReturn;

	var getPrototypeOf = createCommonjsModule(function (module) {
	function _getPrototypeOf(o) {
	  module.exports = _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
	    return o.__proto__ || Object.getPrototypeOf(o);
	  };
	  return _getPrototypeOf(o);
	}

	module.exports = _getPrototypeOf;
	});

	function _defineProperties(target, props) {
	  for (var i = 0; i < props.length; i++) {
	    var descriptor = props[i];
	    descriptor.enumerable = descriptor.enumerable || false;
	    descriptor.configurable = true;
	    if ("value" in descriptor) descriptor.writable = true;
	    Object.defineProperty(target, descriptor.key, descriptor);
	  }
	}

	function _createClass(Constructor, protoProps, staticProps) {
	  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
	  if (staticProps) _defineProperties(Constructor, staticProps);
	  return Constructor;
	}

	var createClass = _createClass;

	var setPrototypeOf = createCommonjsModule(function (module) {
	function _setPrototypeOf(o, p) {
	  module.exports = _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
	    o.__proto__ = p;
	    return o;
	  };

	  return _setPrototypeOf(o, p);
	}

	module.exports = _setPrototypeOf;
	});

	function _inherits(subClass, superClass) {
	  if (typeof superClass !== "function" && superClass !== null) {
	    throw new TypeError("Super expression must either be null or a function");
	  }

	  subClass.prototype = Object.create(superClass && superClass.prototype, {
	    constructor: {
	      value: subClass,
	      writable: true,
	      configurable: true
	    }
	  });
	  if (superClass) setPrototypeOf(subClass, superClass);
	}

	var inherits = _inherits;

	var varValidator = createCommonjsModule(function (module) {
	/**
	Model/Type Name validator
	*/

	const DEFAULT_ENABLE_SCOPE = true;
	const DEFAULT_ENABLE_BRACKETS = false;
	const DEFAULT_ALLOW_UPPERCASE = true;
	const DEFAULT_ALLOW_LOWERCASE = true;

	const TYPE_NAME_REGEX = new RegExp('^(?!(?:do|if|in|for|let|new|try|var|case|else|enum|eval|false|null|this|true|void|with|break|catch|class|const|super|throw|while|yield|delete|export|import|public|return|static|switch|typeof|default|extends|finally|package|private|continue|debugger|function|arguments|interface|protected|implements|instanceof)$)'
	  + '[$A-Z\_a-z\xaa\xb5\xba\xc0-\xd6\xd8-\xf6\xf8-\u02c1\u02c6-\u02d1\u02e0-\u02e4\u02ec\u02ee\u0370-\u0374'
	  + '\u0376\u0377\u037a-\u037d\u0386\u0388-\u038a\u038c\u038e-\u03a1\u03a3-\u03f5\u03f7-\u0481\u048a-\u0527'
	  + '\u0531-\u0556\u0559\u0561-\u0587\u05d0-\u05ea\u05f0-\u05f2\u0620-\u064a\u066e\u066f\u0671-\u06d3\u06d5'
	  + '\u06e5\u06e6\u06ee\u06ef\u06fa-\u06fc\u06ff\u0710\u0712-\u072f\u074d-\u07a5\u07b1\u07ca-\u07ea\u07f4\u07f5'
	  + '\u07fa\u0800-\u0815\u081a\u0824\u0828\u0840-\u0858\u08a0\u08a2-\u08ac\u0904-\u0939\u093d\u0950\u0958-\u0961'
	  + '\u0971-\u0977\u0979-\u097f\u0985-\u098c\u098f\u0990\u0993-\u09a8\u09aa-\u09b0\u09b2\u09b6-\u09b9\u09bd\u09ce'
	  + '\u09dc\u09dd\u09df-\u09e1\u09f0\u09f1\u0a05-\u0a0a\u0a0f\u0a10\u0a13-\u0a28\u0a2a-\u0a30\u0a32\u0a33\u0a35'
	  + '\u0a36\u0a38\u0a39\u0a59-\u0a5c\u0a5e\u0a72-\u0a74\u0a85-\u0a8d\u0a8f-\u0a91\u0a93-\u0aa8\u0aaa-\u0ab0\u0ab2'
	  + '\u0ab3\u0ab5-\u0ab9\u0abd\u0ad0\u0ae0\u0ae1\u0b05-\u0b0c\u0b0f\u0b10\u0b13-\u0b28\u0b2a-\u0b30\u0b32\u0b33'
	  + '\u0b35-\u0b39\u0b3d\u0b5c\u0b5d\u0b5f-\u0b61\u0b71\u0b83\u0b85-\u0b8a\u0b8e-\u0b90\u0b92-\u0b95\u0b99\u0b9a'
	  + '\u0b9c\u0b9e\u0b9f\u0ba3\u0ba4\u0ba8-\u0baa\u0bae-\u0bb9\u0bd0\u0c05-\u0c0c\u0c0e-\u0c10\u0c12-\u0c28\u0c2a-\u0c33'
	  + '\u0c35-\u0c39\u0c3d\u0c58\u0c59\u0c60\u0c61\u0c85-\u0c8c\u0c8e-\u0c90\u0c92-\u0ca8\u0caa-\u0cb3\u0cb5-\u0cb9'
	  + '\u0cbd\u0cde\u0ce0\u0ce1\u0cf1\u0cf2\u0d05-\u0d0c\u0d0e-\u0d10\u0d12-\u0d3a\u0d3d\u0d4e\u0d60\u0d61\u0d7a-\u0d7f'
	  + '\u0d85-\u0d96\u0d9a-\u0db1\u0db3-\u0dbb\u0dbd\u0dc0-\u0dc6\u0e01-\u0e30\u0e32\u0e33\u0e40-\u0e46\u0e81\u0e82'
	  + '\u0e84\u0e87\u0e88\u0e8a\u0e8d\u0e94-\u0e97\u0e99-\u0e9f\u0ea1-\u0ea3\u0ea5\u0ea7\u0eaa\u0eab\u0ead-\u0eb0\u0eb2'
	  + '\u0eb3\u0ebd\u0ec0-\u0ec4\u0ec6\u0edc-\u0edf\u0f00\u0f40-\u0f47\u0f49-\u0f6c\u0f88-\u0f8c\u1000-\u102a\u103f'
	  + '\u1050-\u1055\u105a-\u105d\u1061\u1065\u1066\u106e-\u1070\u1075-\u1081\u108e\u10a0-\u10c5\u10c7\u10cd\u10d0-\u10fa'
	  + '\u10fc-\u1248\u124a-\u124d\u1250-\u1256\u1258\u125a-\u125d\u1260-\u1288\u128a-\u128d\u1290-\u12b0\u12b2-\u12b5'
	  + '\u12b8-\u12be\u12c0\u12c2-\u12c5\u12c8-\u12d6\u12d8-\u1310\u1312-\u1315\u1318-\u135a\u1380-\u138f\u13a0-\u13f4'
	  + '\u1401-\u166c\u166f-\u167f\u1681-\u169a\u16a0-\u16ea\u16ee-\u16f0\u1700-\u170c\u170e-\u1711\u1720-\u1731\u1740-\u1751'
	  + '\u1760-\u176c\u176e-\u1770\u1780-\u17b3\u17d7\u17dc\u1820-\u1877\u1880-\u18a8\u18aa\u18b0-\u18f5\u1900-\u191c'
	  + '\u1950-\u196d\u1970-\u1974\u1980-\u19ab\u19c1-\u19c7\u1a00-\u1a16\u1a20-\u1a54\u1aa7\u1b05-\u1b33\u1b45-\u1b4b'
	  + '\u1b83-\u1ba0\u1bae\u1baf\u1bba-\u1be5\u1c00-\u1c23\u1c4d-\u1c4f\u1c5a-\u1c7d\u1ce9-\u1cec\u1cee-\u1cf1\u1cf5'
	  + '\u1cf6\u1d00-\u1dbf\u1e00-\u1f15\u1f18-\u1f1d\u1f20-\u1f45\u1f48-\u1f4d\u1f50-\u1f57\u1f59\u1f5b\u1f5d\u1f5f-\u1f7d'
	  + '\u1f80-\u1fb4\u1fb6-\u1fbc\u1fbe\u1fc2-\u1fc4\u1fc6-\u1fcc\u1fd0-\u1fd3\u1fd6-\u1fdb\u1fe0-\u1fec\u1ff2-\u1ff4'
	  + '\u1ff6-\u1ffc\u2071\u207f\u2090-\u209c\u2102\u2107\u210a-\u2113\u2115\u2119-\u211d\u2124\u2126\u2128\u212a-\u212d'
	  + '\u212f-\u2139\u213c-\u213f\u2145-\u2149\u214e\u2160-\u2188\u2c00-\u2c2e\u2c30-\u2c5e\u2c60-\u2ce4\u2ceb-\u2cee'
	  + '\u2cf2\u2cf3\u2d00-\u2d25\u2d27\u2d2d\u2d30-\u2d67\u2d6f\u2d80-\u2d96\u2da0-\u2da6\u2da8-\u2dae\u2db0-\u2db6'
	  + '\u2db8-\u2dbe\u2dc0-\u2dc6\u2dc8-\u2dce\u2dd0-\u2dd6\u2dd8-\u2dde\u2e2f\u3005-\u3007\u3021-\u3029\u3031-\u3035'
	  + '\u3038-\u303c\u3041-\u3096\u309d-\u309f\u30a1-\u30fa\u30fc-\u30ff\u3105-\u312d\u3131-\u318e\u31a0-\u31ba'
	  + '\u31f0-\u31ff\u3400-\u4db5\u4e00-\u9fcc\ua000-\ua48c\ua4d0-\ua4fd\ua500-\ua60c\ua610-\ua61f\ua62a\ua62b\ua640-\ua66e'
	  + '\ua67f-\ua697\ua6a0-\ua6ef\ua717-\ua71f\ua722-\ua788\ua78b-\ua78e\ua790-\ua793\ua7a0-\ua7aa\ua7f8-\ua801'
	  + '\ua803-\ua805\ua807-\ua80a\ua80c-\ua822\ua840-\ua873\ua882-\ua8b3\ua8f2-\ua8f7\ua8fb\ua90a-\ua925\ua930-\ua946'
	  + '\ua960-\ua97c\ua984-\ua9b2\ua9cf\uaa00-\uaa28\uaa40-\uaa42\uaa44-\uaa4b\uaa60-\uaa76\uaa7a\uaa80-\uaaaf\uaab1\uaab5'
	  + '\uaab6\uaab9-\uaabd\uaac0\uaac2\uaadb-\uaadd\uaae0-\uaaea\uaaf2-\uaaf4\uab01-\uab06\uab09-\uab0e\uab11-\uab16'
	  + '\uab20-\uab26\uab28-\uab2e\uabc0-\uabe2\uac00-\ud7a3\ud7b0-\ud7c6\ud7cb-\ud7fb\uf900-\ufa6d\ufa70-\ufad9\ufb00-\ufb06'
	  + '\ufb13-\ufb17\ufb1d\ufb1f-\ufb28\ufb2a-\ufb36\ufb38-\ufb3c\ufb3e\ufb40\ufb41\ufb43\ufb44\ufb46-\ufbb1\ufbd3-\ufd3d'
	  + '\ufd50-\ufd8f\ufd92-\ufdc7\ufdf0-\ufdfb\ufe70-\ufe74\ufe76-\ufefc\uff21-\uff3a\uff41-\uff5a\uff66-\uffbe\uffc2-\uffc7'
	  + '\uffca-\uffcf\uffd2-\uffd7\uffda-\uffdc][$A-Z\_a-z\xaa\xb5\xba\xc0-\xd6\xd8-\xf6\xf8-\u02c1\u02c6-\u02d1\u02e0-\u02e4'
	  + '\u02ec\u02ee\u0370-\u0374\u0376\u0377\u037a-\u037d\u0386\u0388-\u038a\u038c\u038e-\u03a1\u03a3-\u03f5\u03f7-\u0481'
	  + '\u048a-\u0527\u0531-\u0556\u0559\u0561-\u0587\u05d0-\u05ea\u05f0-\u05f2\u0620-\u064a\u066e\u066f\u0671-\u06d3\u06d5'
	  + '\u06e5\u06e6\u06ee\u06ef\u06fa-\u06fc\u06ff\u0710\u0712-\u072f\u074d-\u07a5\u07b1\u07ca-\u07ea\u07f4\u07f5\u07fa'
	  + '\u0800-\u0815\u081a\u0824\u0828\u0840-\u0858\u08a0\u08a2-\u08ac\u0904-\u0939\u093d\u0950\u0958-\u0961\u0971-\u0977'
	  + '\u0979-\u097f\u0985-\u098c\u098f\u0990\u0993-\u09a8\u09aa-\u09b0\u09b2\u09b6-\u09b9\u09bd\u09ce\u09dc\u09dd'
	  + '\u09df-\u09e1\u09f0\u09f1\u0a05-\u0a0a\u0a0f\u0a10\u0a13-\u0a28\u0a2a-\u0a30\u0a32\u0a33\u0a35\u0a36\u0a38\u0a39'
	  + '\u0a59-\u0a5c\u0a5e\u0a72-\u0a74\u0a85-\u0a8d\u0a8f-\u0a91\u0a93-\u0aa8\u0aaa-\u0ab0\u0ab2\u0ab3\u0ab5-\u0ab9\u0abd'
	  + '\u0ad0\u0ae0\u0ae1\u0b05-\u0b0c\u0b0f\u0b10\u0b13-\u0b28\u0b2a-\u0b30\u0b32\u0b33\u0b35-\u0b39\u0b3d\u0b5c\u0b5d'
	  + '\u0b5f-\u0b61\u0b71\u0b83\u0b85-\u0b8a\u0b8e-\u0b90\u0b92-\u0b95\u0b99\u0b9a\u0b9c\u0b9e\u0b9f\u0ba3\u0ba4'
	  + '\u0ba8-\u0baa\u0bae-\u0bb9\u0bd0\u0c05-\u0c0c\u0c0e-\u0c10\u0c12-\u0c28\u0c2a-\u0c33\u0c35-\u0c39\u0c3d\u0c58\u0c59'
	  + '\u0c60\u0c61\u0c85-\u0c8c\u0c8e-\u0c90\u0c92-\u0ca8\u0caa-\u0cb3\u0cb5-\u0cb9\u0cbd\u0cde\u0ce0\u0ce1\u0cf1\u0cf2'
	  + '\u0d05-\u0d0c\u0d0e-\u0d10\u0d12-\u0d3a\u0d3d\u0d4e\u0d60\u0d61\u0d7a-\u0d7f\u0d85-\u0d96\u0d9a-\u0db1\u0db3-\u0dbb'
	  + '\u0dbd\u0dc0-\u0dc6\u0e01-\u0e30\u0e32\u0e33\u0e40-\u0e46\u0e81\u0e82\u0e84\u0e87\u0e88\u0e8a\u0e8d\u0e94-\u0e97'
	  + '\u0e99-\u0e9f\u0ea1-\u0ea3\u0ea5\u0ea7\u0eaa\u0eab\u0ead-\u0eb0\u0eb2\u0eb3\u0ebd\u0ec0-\u0ec4\u0ec6\u0edc-\u0edf\u0f00'
	  + '\u0f40-\u0f47\u0f49-\u0f6c\u0f88-\u0f8c\u1000-\u102a\u103f\u1050-\u1055\u105a-\u105d\u1061\u1065\u1066\u106e-\u1070'
	  + '\u1075-\u1081\u108e\u10a0-\u10c5\u10c7\u10cd\u10d0-\u10fa\u10fc-\u1248\u124a-\u124d\u1250-\u1256\u1258\u125a-\u125d'
	  + '\u1260-\u1288\u128a-\u128d\u1290-\u12b0\u12b2-\u12b5\u12b8-\u12be\u12c0\u12c2-\u12c5\u12c8-\u12d6\u12d8-\u1310'
	  + '\u1312-\u1315\u1318-\u135a\u1380-\u138f\u13a0-\u13f4\u1401-\u166c\u166f-\u167f\u1681-\u169a\u16a0-\u16ea\u16ee-\u16f0'
	  + '\u1700-\u170c\u170e-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176c\u176e-\u1770\u1780-\u17b3\u17d7\u17dc\u1820-\u1877'
	  + '\u1880-\u18a8\u18aa\u18b0-\u18f5\u1900-\u191c\u1950-\u196d\u1970-\u1974\u1980-\u19ab\u19c1-\u19c7\u1a00-\u1a16'
	  + '\u1a20-\u1a54\u1aa7\u1b05-\u1b33\u1b45-\u1b4b\u1b83-\u1ba0\u1bae\u1baf\u1bba-\u1be5\u1c00-\u1c23\u1c4d-\u1c4f'
	  + '\u1c5a-\u1c7d\u1ce9-\u1cec\u1cee-\u1cf1\u1cf5\u1cf6\u1d00-\u1dbf\u1e00-\u1f15\u1f18-\u1f1d\u1f20-\u1f45\u1f48-\u1f4d'
	  + '\u1f50-\u1f57\u1f59\u1f5b\u1f5d\u1f5f-\u1f7d\u1f80-\u1fb4\u1fb6-\u1fbc\u1fbe\u1fc2-\u1fc4\u1fc6-\u1fcc\u1fd0-\u1fd3'
	  + '\u1fd6-\u1fdb\u1fe0-\u1fec\u1ff2-\u1ff4\u1ff6-\u1ffc\u2071\u207f\u2090-\u209c\u2102\u2107\u210a-\u2113\u2115'
	  + '\u2119-\u211d\u2124\u2126\u2128\u212a-\u212d\u212f-\u2139\u213c-\u213f\u2145-\u2149\u214e\u2160-\u2188\u2c00-\u2c2e'
	  + '\u2c30-\u2c5e\u2c60-\u2ce4\u2ceb-\u2cee\u2cf2\u2cf3\u2d00-\u2d25\u2d27\u2d2d\u2d30-\u2d67\u2d6f\u2d80-\u2d96'
	  + '\u2da0-\u2da6\u2da8-\u2dae\u2db0-\u2db6\u2db8-\u2dbe\u2dc0-\u2dc6\u2dc8-\u2dce\u2dd0-\u2dd6\u2dd8-\u2dde\u2e2f'
	  + '\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303c\u3041-\u3096\u309d-\u309f\u30a1-\u30fa\u30fc-\u30ff\u3105-\u312d'
	  + '\u3131-\u318e\u31a0-\u31ba\u31f0-\u31ff\u3400-\u4db5\u4e00-\u9fcc\ua000-\ua48c\ua4d0-\ua4fd\ua500-\ua60c\ua610-\ua61f'
	  + '\ua62a\ua62b\ua640-\ua66e\ua67f-\ua697\ua6a0-\ua6ef\ua717-\ua71f\ua722-\ua788\ua78b-\ua78e\ua790-\ua793\ua7a0-\ua7aa'
	  + '\ua7f8-\ua801\ua803-\ua805\ua807-\ua80a\ua80c-\ua822\ua840-\ua873\ua882-\ua8b3\ua8f2-\ua8f7\ua8fb\ua90a-\ua925'
	  + '\ua930-\ua946\ua960-\ua97c\ua984-\ua9b2\ua9cf\uaa00-\uaa28\uaa40-\uaa42\uaa44-\uaa4b\uaa60-\uaa76\uaa7a\uaa80-\uaaaf'
	  + '\uaab1\uaab5\uaab6\uaab9-\uaabd\uaac0\uaac2\uaadb-\uaadd\uaae0-\uaaea\uaaf2-\uaaf4\uab01-\uab06\uab09-\uab0e'
	  + '\uab11-\uab16\uab20-\uab26\uab28-\uab2e\uabc0-\uabe2\uac00-\ud7a3\ud7b0-\ud7c6\ud7cb-\ud7fb\uf900-\ufa6d'
	  + '\ufa70-\ufad9\ufb00-\ufb06\ufb13-\ufb17\ufb1d\ufb1f-\ufb28\ufb2a-\ufb36\ufb38-\ufb3c\ufb3e\ufb40\ufb41\ufb43\ufb44'
	  + '\ufb46-\ufbb1\ufbd3-\ufd3d\ufd50-\ufd8f\ufd92-\ufdc7\ufdf0-\ufdfb\ufe70-\ufe74\ufe76-\ufefc\uff21-\uff3a\uff41-\uff5a'
	  + '\uff66-\uffbe\uffc2-\uffc7\uffca-\uffcf\uffd2-\uffd7\uffda-\uffdc0-9\u0300-\u036f\u0483-\u0487\u0591-\u05bd\u05bf'
	  + '\u05c1\u05c2\u05c4\u05c5\u05c7\u0610-\u061a\u064b-\u0669\u0670\u06d6-\u06dc\u06df-\u06e4\u06e7\u06e8\u06ea-\u06ed'
	  + '\u06f0-\u06f9\u0711\u0730-\u074a\u07a6-\u07b0\u07c0-\u07c9\u07eb-\u07f3\u0816-\u0819\u081b-\u0823\u0825-\u0827'
	  + '\u0829-\u082d\u0859-\u085b\u08e4-\u08fe\u0900-\u0903\u093a-\u093c\u093e-\u094f\u0951-\u0957\u0962\u0963\u0966-\u096f'
	  + '\u0981-\u0983\u09bc\u09be-\u09c4\u09c7\u09c8\u09cb-\u09cd\u09d7\u09e2\u09e3\u09e6-\u09ef\u0a01-\u0a03\u0a3c'
	  + '\u0a3e-\u0a42\u0a47\u0a48\u0a4b-\u0a4d\u0a51\u0a66-\u0a71\u0a75\u0a81-\u0a83\u0abc\u0abe-\u0ac5\u0ac7-\u0ac9'
	  + '\u0acb-\u0acd\u0ae2\u0ae3\u0ae6-\u0aef\u0b01-\u0b03\u0b3c\u0b3e-\u0b44\u0b47\u0b48\u0b4b-\u0b4d\u0b56\u0b57\u0b62'
	  + '\u0b63\u0b66-\u0b6f\u0b82\u0bbe-\u0bc2\u0bc6-\u0bc8\u0bca-\u0bcd\u0bd7\u0be6-\u0bef\u0c01-\u0c03\u0c3e-\u0c44'
	  + '\u0c46-\u0c48\u0c4a-\u0c4d\u0c55\u0c56\u0c62\u0c63\u0c66-\u0c6f\u0c82\u0c83\u0cbc\u0cbe-\u0cc4\u0cc6-\u0cc8'
	  + '\u0cca-\u0ccd\u0cd5\u0cd6\u0ce2\u0ce3\u0ce6-\u0cef\u0d02\u0d03\u0d3e-\u0d44\u0d46-\u0d48\u0d4a-\u0d4d\u0d57\u0d62'
	  + '\u0d63\u0d66-\u0d6f\u0d82\u0d83\u0dca\u0dcf-\u0dd4\u0dd6\u0dd8-\u0ddf\u0df2\u0df3\u0e31\u0e34-\u0e3a\u0e47-\u0e4e'
	  + '\u0e50-\u0e59\u0eb1\u0eb4-\u0eb9\u0ebb\u0ebc\u0ec8-\u0ecd\u0ed0-\u0ed9\u0f18\u0f19\u0f20-\u0f29\u0f35\u0f37\u0f39'
	  + '\u0f3e\u0f3f\u0f71-\u0f84\u0f86\u0f87\u0f8d-\u0f97\u0f99-\u0fbc\u0fc6\u102b-\u103e\u1040-\u1049\u1056-\u1059'
	  + '\u105e-\u1060\u1062-\u1064\u1067-\u106d\u1071-\u1074\u1082-\u108d\u108f-\u109d\u135d-\u135f\u1712-\u1714\u1732-\u1734'
	  + '\u1752\u1753\u1772\u1773\u17b4-\u17d3\u17dd\u17e0-\u17e9\u180b-\u180d\u1810-\u1819\u18a9\u1920-\u192b\u1930-\u193b'
	  + '\u1946-\u194f\u19b0-\u19c0\u19c8\u19c9\u19d0-\u19d9\u1a17-\u1a1b\u1a55-\u1a5e\u1a60-\u1a7c\u1a7f-\u1a89\u1a90-\u1a99'
	  + '\u1b00-\u1b04\u1b34-\u1b44\u1b50-\u1b59\u1b6b-\u1b73\u1b80-\u1b82\u1ba1-\u1bad\u1bb0-\u1bb9\u1be6-\u1bf3\u1c24-\u1c37'
	  + '\u1c40-\u1c49\u1c50-\u1c59\u1cd0-\u1cd2\u1cd4-\u1ce8\u1ced\u1cf2-\u1cf4\u1dc0-\u1de6\u1dfc-\u1dff\u200c\u200d\u203f'
	  + '\u2040\u2054\u20d0-\u20dc\u20e1\u20e5-\u20f0\u2cef-\u2cf1\u2d7f\u2de0-\u2dff\u302a-\u302f\u3099\u309a\ua620-\ua629'
	  + '\ua66f\ua674-\ua67d\ua69f\ua6f0\ua6f1\ua802\ua806\ua80b\ua823-\ua827\ua880\ua881\ua8b4-\ua8c4\ua8d0-\ua8d9\ua8e0-\ua8f1'
	  + '\ua900-\ua909\ua926-\ua92d\ua947-\ua953\ua980-\ua983\ua9b3-\ua9c0\ua9d0-\ua9d9\uaa29-\uaa36\uaa43\uaa4c\uaa4d\uaa50-\uaa59'
	  + '\uaa7b\uaab0\uaab2-\uaab4\uaab7\uaab8\uaabe\uaabf\uaac1\uaaeb-\uaaef\uaaf5\uaaf6\uabe3-\uabea\uabec\uabed\uabf0-\uabf9'
	  + '\ufb1e\ufe00-\ufe0f\ufe20-\ufe26\ufe33\ufe34\ufe4d-\ufe4f\uff10-\uff19\uff3f]*$');

	const SCOPE_SEPARATOR = '.';
	const BRACKET_PATTERN = /^([^\[\]]+)(?:\s*\[\s*(["']?)\s*(.*)?\s*\2\s*\])?$/;
	const NUMERIC_KEY_PATTERN = /^[0-9]+$/;

	var defaultOptions = {
	  enableScope: DEFAULT_ENABLE_SCOPE,
	  enableBrackets: DEFAULT_ENABLE_BRACKETS,
	  allowUpperCase: DEFAULT_ALLOW_UPPERCASE,
	  allowLowerCase: DEFAULT_ALLOW_LOWERCASE
	};
	var optionsKeys = Object.keys(defaultOptions);

	/**
	Expose function as module
	*/
	module.exports.isValid = validateName;

	/**
	Expose default settings
	*/
	Object.defineProperties(module.exports, {
	  enableScope: {
	    enumerable: true,
	    configurable: false,
	    get: function getEnableScope()  { return defaultOptions.enableScope; },
	    set: function setEnableScope(v) { defaultOptions.enableScope = v; }
	  },
	  enableBrackets: {
	    enumerable: true,
	    configurable: false,
	    get: function getEnableBrackets()  { return defaultOptions.enableBrackets; },
	    set: function setEnableBrackets(v) { defaultOptions.enableBrackets = v; }
	  },
	  allowUpperCase: {
	    enumerable: true,
	    configurable: false,
	    get: function getAllowUpperCase()  { return defaultOptions.allowUpperCase; },
	    set: function setAllowUpCerCase(v) { defaultOptions.allowUpperCase = v; }
	  },
	  allowLowerCase: {
	    enumerable: true,
	    configurable: false,
	    get: function getAllowLowerCase()  { return defaultOptions.allowLowerCase; },
	    set: function setAllowLowerCase(v) { defaultOptions.allowLowerCase = v; }
	  }
	});

	/**
	Validate the given name and make sure it is valid. The value must be a valid String

	@param {String} name                 the name to validate
	@param {Object} options   (optional) option overrides
	@return {Boolean}                    true if the val is valid, false otherwise
	*/
	function validateName(name, options) {
	  var nameParts;
	  var i;
	  var iLen;
	  var key;
	  var keyMatch;
	  var keyKey;
	  var opt;

	  if (options && (options.constructor.name === 'Object')) {
	    opt = {};

	    for (i = 0, iLen = optionsKeys.length; i < iLen; ++i) {
	      key = optionsKeys[i];
	      if (key in options) {
	        opt[key] = options[key];
	      } else {
	        opt[key] = defaultOptions[key];
	      }
	    }
	  } else {
	    opt = defaultOptions;
	  }

	  function invalidVar(v) {
	    return !TYPE_NAME_REGEX.test(v) ||
	           (!opt.allowLowerCase && v.toLocaleUpperCase() != v) ||
	           (!opt.allowUpperCase && v.toLocaleLowerCase() != v)
	  }

	  if (typeof name === 'string') {
	    if (opt.enableScope) {
	      nameParts = name.split(SCOPE_SEPARATOR);
	    } else {
	      nameParts = [name];
	    }

	    for (i = 0, iLen = nameParts.length; i < iLen; ++i) {
	      key = nameParts[i];

	      if (opt.enableBrackets) {
	        keyMatch = key.match(BRACKET_PATTERN);

	        if (!keyMatch ||
	            invalidVar(keyMatch[1].trim()) ||
	            (!keyMatch[2] && keyMatch[3] && !NUMERIC_KEY_PATTERN.test(keyKey = keyMatch[3].trim()) && invalidVar(keyKey))
	           ) {

	          return false;
	        }
	      } else if (invalidVar(key)) {

	        return false;
	      }
	    }

	    return true;
	  } else {

	    return false;
	  }
	}
	});
	var varValidator_1 = varValidator.isValid;

	var _extends_1 = createCommonjsModule(function (module) {
	function _extends() {
	  module.exports = _extends = Object.assign || function (target) {
	    for (var i = 1; i < arguments.length; i++) {
	      var source = arguments[i];

	      for (var key in source) {
	        if (Object.prototype.hasOwnProperty.call(source, key)) {
	          target[key] = source[key];
	        }
	      }
	    }

	    return target;
	  };

	  return _extends.apply(this, arguments);
	}

	module.exports = _extends;
	});

	var ValidationContext =
	/*#__PURE__*/
	function () {
	  function ValidationContext(schema) {
	    classCallCheck(this, ValidationContext);

	    Object.defineProperties(this, {
	      schema: {
	        enumerable: true,
	        configurable: false,
	        writable: false,
	        value: schema
	      },
	      _messages: {
	        enumerable: false,
	        configurable: true,
	        writable: true,
	        value: {}
	      },
	      _valid: {
	        enumerable: false,
	        configurable: true,
	        writable: true,
	        value: true
	      }
	    });
	  }

	  createClass(ValidationContext, [{
	    key: "isValid",
	    value: function isValid() {
	      return this._valid;
	    }
	  }, {
	    key: "getMessages",
	    value: function getMessages() {
	      return _extends_1({}, this._messages);
	    }
	  }, {
	    key: "getMessage",
	    value: function getMessage(field) {
	      return this._messages[field];
	    }
	  }, {
	    key: "setMessage",
	    value: function setMessage(field, message) {
	      if (typeof field !== 'string') {
	        throw new TypeError('Invalid field value');
	      } else if (!(field.split('.')[0] in this.schema.fields)) {
	        throw new Error('Unknown field : ' + field + ' (' + this.schema.fieldNames.join(', ') + ')');
	      } else if (message && typeof message !== 'string') {
	        throw new TypeError('Invalid message for ' + field);
	      } else if (message) {
	        this._messages[field] = message;
	      } else {
	        delete this._messages[field];
	      }

	      this._valid = !Object.keys(this._messages).length;
	    }
	  }, {
	    key: "reset",
	    value: function reset() {
	      this._messages = {};
	      this._valid = true;
	    }
	  }, {
	    key: "validate",
	    value: function validate(data) {
	      var _this = this;

	      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
	      var _this$schema = this.schema,
	          fieldNames = _this$schema.fieldNames,
	          fields = _this$schema.fields;
	      var validateFieldNames = options.fields,
	          _options$validatorOpt = options.validatorOptions,
	          validatorOptions = _options$validatorOpt === void 0 ? {} : _options$validatorOpt;

	      if (_typeof_1(data) !== 'object') {
	        throw new TypeError('Data must be an object');
	      } // reset 'notInSchema' errors


	      Object.keys(this._messages).forEach(function (fieldName) {
	        if (_this._messages[fieldName] === 'notInSchema') {
	          delete _this._messages[fieldName];
	        }
	      }); // set 'notInSchema' errors

	      (validateFieldNames || Object.keys(data)).forEach(function (fieldName) {
	        if (!(fieldName in fields)) {
	          _this._messages[fieldName] = 'notInSchema';
	        }
	      });
	      (validateFieldNames || fieldNames).forEach(function (fieldName) {
	        Object.keys(_this._messages).forEach(function (messageKey) {
	          if (messageKey.split('.')[0] === fieldName) {
	            delete _this._messages[messageKey];
	          }
	        });
	        var field = fields[fieldName];
	        var value = data[fieldName];
	        var self = {
	          fieldName: fieldName,
	          options: validatorOptions,
	          getField: function getField(fieldName) {
	            var path = typeof fieldName === 'string' ? fieldName.split('.') : undefined;
	            var value = data;
	            var exists = true;

	            if (!path) {
	              throw new TypeError('Invalid fieldName');
	            }

	            for (var index = 0, len = path.length; index < len; ++index) {
	              if (value && _typeof_1(value) === 'object' && path[index] in value) {
	                value = value[path[index]];
	              } else {
	                value = undefined;
	                exists = false;
	              }
	            }

	            return {
	              exists: exists,
	              value: value
	            };
	          }
	        };
	        var result = field.validator(value, self, _this);

	        if (result && typeof result === 'string') {
	          _this._messages[fieldName] = result;
	        }
	      });
	      return this._valid = !Object.keys(this._messages).length;
	    }
	  }]);

	  return ValidationContext;
	}();

	/**
	Create a new model given the specified fields

	@param schema {Schema}
	@return {Object}
	*/
	function createModel(schema, data) {
	  var fields = schema.fields,
	      fieldNames = schema.fieldNames;

	  var model = _extends_1({}, data || {});

	  var _iteratorNormalCompletion = true;
	  var _didIteratorError = false;
	  var _iteratorError = undefined;

	  try {
	    for (var _iterator = fieldNames[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
	      var fieldName = _step.value;
	      var field = fields[fieldName];

	      if (!(fieldName in model) && 'defaultValue' in field) {
	        model[fieldName] = typeof field.defaultValue === 'function' ? field.defaultValue() : field.defaultValue;
	      }
	    }
	  } catch (err) {
	    _didIteratorError = true;
	    _iteratorError = err;
	  } finally {
	    try {
	      if (!_iteratorNormalCompletion && _iterator["return"] != null) {
	        _iterator["return"]();
	      }
	    } finally {
	      if (_didIteratorError) {
	        throw _iteratorError;
	      }
	    }
	  }

	  return model;
	}

	function _arrayWithoutHoles(arr) {
	  if (Array.isArray(arr)) {
	    for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) {
	      arr2[i] = arr[i];
	    }

	    return arr2;
	  }
	}

	var arrayWithoutHoles = _arrayWithoutHoles;

	function _iterableToArray(iter) {
	  if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
	}

	var iterableToArray = _iterableToArray;

	function _nonIterableSpread() {
	  throw new TypeError("Invalid attempt to spread non-iterable instance");
	}

	var nonIterableSpread = _nonIterableSpread;

	function _toConsumableArray(arr) {
	  return arrayWithoutHoles(arr) || iterableToArray(arr) || nonIterableSpread();
	}

	var toConsumableArray = _toConsumableArray;

	/**
	Any type

	Usage:

	   {
	     a: SchemaType.Any
	   }

	See schema.js for more information
	*/
	var AnyType = Object.freeze({
	  $$type: Symbol('any'),
	  $$primitive: '*',
	  validatorFactory: anyValidator
	});
	/**
	Validation function favtory

	@param fieldName {String}           the field name being eva
	@param field {Object}               the field options
	@param schema {Schema}              the schema instance
	@param wrappedValidator {Function}  (optional) the validator being wrapped
	*/

	function anyValidator(fieldName, field, schema, wrappedValidator) {
	  var _field$required = field.required,
	      required = _field$required === void 0 ? false : _field$required,
	      _field$nullable = field.nullable,
	      nullable = _field$nullable === void 0 ? true : _field$nullable;
	  return function validator(value, self, context) {
	    if (value === undefined && required) {
	      return 'required';
	    } else if (value === null && !nullable) {
	      return 'isNull';
	    }

	    return wrappedValidator && wrappedValidator(value, self, context);
	  };
	}

	var TYPE = Symbol('anyOf');
	/**
	Array of type

	Usage:

	   {
	     a: SchemaType.Any
	   }

	See schema.js for more information
	*/

	var AnyOfType = (function () {
	  return Object.freeze({
	    $$type: TYPE,
	    validatorFactory: validatorFactory.apply(void 0, arguments)
	  });
	});

	function validatorFactory() {
	  for (var _len = arguments.length, allowedTypes = new Array(_len), _key = 0; _key < _len; _key++) {
	    allowedTypes[_key] = arguments[_key];
	  }

	  if (!allowedTypes.filter(function (type) {
	    return type;
	  }).length) {
	    throw new TypeError('Missing types');
	  }
	  /**
	  Validation function favtory
	   @param fieldName {String}           the field name being eva
	  @param field {Object}               the field options
	  @param schema {Schema}              the schema instance
	  @param wrappedValidator {Function}  (optional) the validator being wrapped
	  */


	  return function anyOfValidator(fieldName, field, schema, wrappedValidator) {
	    var _field$required = field.required,
	        required = _field$required === void 0 ? false : _field$required,
	        _field$nullable = field.nullable,
	        nullable = _field$nullable === void 0 ? true : _field$nullable;
	    var baseFields = allowedTypes.map(function (baseType) {
	      return schema._normalizeField(baseType, fieldName);
	    });
	    var itemValidators = baseFields.map(function (baseField) {
	      return baseField.type.validatorFactory(fieldName, field, schema);
	    });
	    return function validator(value, self, context) {
	      if (value === undefined && required) {
	        return 'required';
	      } else if (value === null && !nullable) {
	        return 'isNull';
	      } else if (value !== undefined && value !== null) {
	        var message;
	        var validFound = false;
	        var _iteratorNormalCompletion = true;
	        var _didIteratorError = false;
	        var _iteratorError = undefined;

	        try {
	          for (var _iterator = itemValidators[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
	            var itemValidator = _step.value;

	            var _message = itemValidator(value);

	            if (!_message) {
	              validFound = true;
	            } else if (!message) {
	              message = _message;
	            }
	          }
	        } catch (err) {
	          _didIteratorError = true;
	          _iteratorError = err;
	        } finally {
	          try {
	            if (!_iteratorNormalCompletion && _iterator["return"] != null) {
	              _iterator["return"]();
	            }
	          } finally {
	            if (_didIteratorError) {
	              throw _iteratorError;
	            }
	          }
	        }

	        if (!validFound && typeof message === 'string') {
	          return message;
	        }
	      }

	      return wrappedValidator && wrappedValidator(value, self, context);
	    };
	  };
	}

	/**
	Array type

	Usage:

	   {
	     a: Array
	   }

	See schema.js for more information
	*/
	var ArrayType = Object.freeze({
	  $$type: Symbol('array'),
	  $$primitive: Array,
	  validatorFactory: arrayValidator
	});
	/**
	Validation function favtory

	@param fieldName {String}           the field name being eva
	@param field {Object}               the field options
	@param schema {Schema}              the schema instance
	@param wrappedValidator {Function}  (optional) the validator being wrapped
	*/

	function arrayValidator(fieldName, field, schema, wrappedValidator) {
	  var _field$required = field.required,
	      required = _field$required === void 0 ? false : _field$required,
	      _field$nullable = field.nullable,
	      nullable = _field$nullable === void 0 ? true : _field$nullable,
	      _field$minCount = field.minCount,
	      minCount = _field$minCount === void 0 ? 0 : _field$minCount,
	      _field$maxCount = field.maxCount,
	      maxCount = _field$maxCount === void 0 ? Infinity : _field$maxCount;
	  return function validator(value, self, context) {
	    if (value === undefined && required) {
	      return 'required';
	    } else if (value === null && !nullable) {
	      return 'isNull';
	    } else if (value !== undefined && value !== null) {
	      if (!Array.isArray(value)) {
	        return 'invalidType';
	      } else if (value.length < minCount) {
	        return 'minCount';
	      } else if (value.length > maxCount) {
	        return 'maxCount';
	      }
	    }

	    return wrappedValidator && wrappedValidator(value, self, context);
	  };
	}

	var TYPE$1 = Symbol('arrayOf');
	/**
	Array of type

	Usage:

	   {
	     a: SchemaType.Any
	   }

	See schema.js for more information
	*/

	var ArrayOfType = (function (type) {
	  return Object.freeze({
	    $$type: TYPE$1,
	    validatorFactory: validatorFactory$1(type)
	  });
	});

	function validatorFactory$1(baseType) {
	  if (!baseType) {
	    throw new TypeError('Missing type');
	  }
	  /**
	  Validation function favtory
	   @param fieldName {String}           the field name being eva
	  @param field {Object}               the field options
	  @param schema {Schema}              the schema instance
	  @param wrappedValidator {Function}  (optional) the validator being wrapped
	  */


	  return function arrayOfValidator(fieldName, field, schema, wrappedValidator) {
	    var _field$timeout = field.timeout,
	        timeout = _field$timeout === void 0 ? 200 : _field$timeout;

	    var baseField = schema._normalizeField(baseType, fieldName + '.*');

	    var itemValidator = baseField.type.validatorFactory(null, baseField, schema);
	    return ArrayType.validatorFactory(fieldName, field, schema, function (value, self, context) {
	      if (value) {
	        var expires = Date.now() + timeout;

	        var _loop = function _loop(i, len) {
	          var item = value[i];
	          var itemContext = itemValidator.context;
	          var message = itemValidator(item, self, itemContext);

	          if (typeof message === 'string') {
	            if (itemContext && fieldName) {
	              var contextMessages = itemContext.getMessages();
	              Object.keys(contextMessages).forEach(function (subFieldName) {
	                return context.setMessage(fieldName + '.' + i + '.' + subFieldName, contextMessages[subFieldName]);
	              });
	            }

	            return {
	              v: 'invalid'
	            };
	          }
	        };

	        for (var i = 0, len = value.length; i < len && expires > Date.now(); ++i) {
	          var _ret = _loop(i, len);

	          if (_typeof_1(_ret) === "object") return _ret.v;
	        }
	      }

	      return wrappedValidator && wrappedValidator(value, self, context);
	    });
	  };
	}

	/**
	Boolean type

	Usage:

	   {
	     a: Boolean
	   }

	See schema.js for more information
	*/
	var BooleanType = Object.freeze({
	  $$type: Symbol('boolean'),
	  $$primitive: Boolean,
	  validatorFactory: booleanValidator
	});
	/**
	Validation function favtory

	@param fieldName {String}           the field name being eva
	@param field {Object}               the field options
	@param schema {Schema}              the schema instance
	@param wrappedValidator {Function}  (optional) the validator being wrapped
	*/

	function booleanValidator(fieldName, field, schema, wrappedValidator) {
	  var _field$required = field.required,
	      required = _field$required === void 0 ? false : _field$required,
	      _field$nullable = field.nullable,
	      nullable = _field$nullable === void 0 ? true : _field$nullable;
	  return function validator(value, self, context) {
	    if (value === undefined && required) {
	      return 'required';
	    } else if (value === null && !nullable) {
	      return 'isNull';
	    } else if (value !== undefined && value !== null && value !== true && value !== false) {
	      return 'invalidType';
	    }

	    return wrappedValidator && wrappedValidator(value, self, context);
	  };
	}

	/**
	Date type

	Usage:

	   {
	     a: Date
	   }

	See schema.js for more information
	*/
	var DateType = Object.freeze({
	  $$type: Symbol('date'),
	  $$primitive: Date,
	  validatorFactory: dateValidator
	});
	/**
	Validation function favtory

	@param fieldName {String}           the field name being eva
	@param field {Object}               the field options
	@param schema {Schema}              the schema instance
	@param wrappedValidator {Function}  (optional) the validator being wrapped
	*/

	function dateValidator(fieldName, field, schema, wrappedValidator) {
	  var _field$required = field.required,
	      required = _field$required === void 0 ? false : _field$required,
	      _field$nullable = field.nullable,
	      nullable = _field$nullable === void 0 ? true : _field$nullable,
	      _field$minDate = field.minDate,
	      minDate = _field$minDate === void 0 ? -Infinity : _field$minDate,
	      _field$maxDate = field.maxDate,
	      maxDate = _field$maxDate === void 0 ? Infinity : _field$maxDate;
	  return function validator(value, self, context) {
	    if (value === undefined && required) {
	      return 'required';
	    } else if (value === null && !nullable) {
	      return 'isNull';
	    } else if (value !== undefined && value !== null) {
	      if (!(value instanceof Date)) {
	        return 'invalidType';
	      } else if (isNaN(value.getTime())) {
	        return 'invalidDate';
	      } else if (value < minDate) {
	        return 'minDate';
	      } else if (value > maxDate) {
	        return 'maxDate';
	      }
	    }

	    return wrappedValidator && wrappedValidator(value, self, context);
	  };
	}

	/**
	Number type

	Usage:

	   {
	     a: Number
	   }

	See schema.js for more information
	*/
	var NumberType = Object.freeze({
	  $$type: Symbol('number'),
	  $$primitive: Number,
	  validatorFactory: numberValidator
	});
	/**
	Validation function favtory

	@param fieldName {String}           the field name being eva
	@param field {Object}               the field options
	@param schema {Schema}              the schema instance
	@param wrappedValidator {Function}  (optional) the validator being wrapped
	*/

	function numberValidator(fieldName, field, schema, wrappedValidator) {
	  var _field$required = field.required,
	      required = _field$required === void 0 ? false : _field$required,
	      _field$nullable = field.nullable,
	      nullable = _field$nullable === void 0 ? true : _field$nullable,
	      _field$minNumber = field.minNumber,
	      minNumber = _field$minNumber === void 0 ? -Infinity : _field$minNumber,
	      _field$maxNumber = field.maxNumber,
	      maxNumber = _field$maxNumber === void 0 ? Infinity : _field$maxNumber;
	  return function validator(value, self, context) {
	    if (value === undefined && required) {
	      return 'required';
	    } else if (value === null && !nullable) {
	      return 'isNull';
	    } else if (value !== undefined && value !== null) {
	      if (typeof value !== 'number' || isNaN(value)) {
	        return 'invalidType';
	      } else if (value < minNumber) {
	        return 'minNumber';
	      } else if (value > maxNumber) {
	        return 'maxNumber';
	      }
	    }

	    return wrappedValidator && wrappedValidator(value, self, context);
	  };
	}

	/**
	Integer type

	Usage:

	   {
	     a: SchemaType.Integer
	   }

	See schema.js for more information
	*/

	var IntegerType = Object.freeze({
	  $$type: Symbol('integer'),
	  validatorFactory: integerValidator
	});
	/**
	Validation function favtory

	@param fieldName {String}           the field name being eva
	@param field {Object}               the field options
	@param schema {Schema}              the schema instance
	@param wrappedValidator {Function}  (optional) the validator being wrapped
	*/

	function integerValidator(fieldName, field, schema, wrappedValidator) {
	  return NumberType.validatorFactory(fieldName, field, schema, function (value, self, context) {
	    if (value) {
	      if ((value | 0) !== value || value === -Infinity || value === Infinity) {
	        return 'invalidType';
	      }
	    }

	    return wrappedValidator && wrappedValidator(value, self, context);
	  });
	}

	/**
	Object type

	Usage:

	   {
	     a: Object
	   }

	See schema.js for more information
	*/
	var ObjectType = Object.freeze({
	  $$type: Symbol('object'),
	  $$primitive: Object,
	  validatorFactory: objectValidator
	});
	var proto = Object.prototype;
	var gpo = Object.getPrototypeOf;
	/**
	Validation function favtory

	@param fieldName {String}           the field name being eva
	@param field {Object}               the field options
	@param schema {Schema}              the schema instance
	@param wrappedValidator {Function}  (optional) the validator being wrapped
	*/

	function objectValidator(fieldName, field, schema, wrappedValidator) {
	  var _field$required = field.required,
	      required = _field$required === void 0 ? false : _field$required,
	      _field$nullable = field.nullable,
	      nullable = _field$nullable === void 0 ? true : _field$nullable;
	  return function validator(value, self, context) {
	    if (value === undefined && required) {
	      return 'required';
	    } else if (value === null && !nullable) {
	      return 'isNull';
	    } else if (value !== undefined && value !== null && (_typeof_1(value) !== 'object' || gpo(value) !== proto)) {
	      return 'invalidType';
	    }

	    return wrappedValidator && wrappedValidator(value, self, context);
	  };
	}

	/**
	String type

	Usage:

	   {
	     a: String
	   }

	See schema.js for more information
	*/
	var StringType = Object.freeze({
	  $$type: Symbol('string'),
	  $$primitive: String,
	  validatorFactory: stringValidator
	});
	/**
	Validation function favtory

	@param fieldName {String}           the field name being eva
	@param field {Object}               the field options
	@param schema {Schema}              the schema instance
	@param wrappedValidator {Function}  (optional) the validator being wrapped
	*/

	function stringValidator(fieldName, field, schema, wrappedValidator) {
	  var _field$required = field.required,
	      required = _field$required === void 0 ? false : _field$required,
	      _field$nullable = field.nullable,
	      nullable = _field$nullable === void 0 ? true : _field$nullable,
	      _field$minLength = field.minLength,
	      minLength = _field$minLength === void 0 ? 0 : _field$minLength,
	      _field$maxLength = field.maxLength,
	      maxLength = _field$maxLength === void 0 ? Infinity : _field$maxLength;
	  return function validator(value, self, context) {
	    if (value === undefined && required) {
	      return 'required';
	    } else if (value === null && !nullable) {
	      return 'isNull';
	    } else if (value !== undefined && value !== null) {
	      if (typeof value !== 'string') {
	        return 'invalidType';
	      } else if (value.length < minLength) {
	        return 'minLength';
	      } else if (value.length > maxLength) {
	        return 'maxLength';
	      }
	    }

	    return wrappedValidator && wrappedValidator(value, self, context);
	  };
	}

	var typeMap = [AnyType, ArrayType, BooleanType, DateType, NumberType, ObjectType, StringType].reduce(function (map, type) {
	  map[String(type.$$type).slice(7, -1)] = type;
	  map[type.$$primitive] = type;
	  return map;
	}, {});

	function isType(type) {
	  return type && (type instanceof TypeProvider || typeMap[type] || type.$$type && !Array.isArray(type.$$type) && typeof type.validatorFactory === 'function') || false;
	}

	function getType(type) {
	  if (type instanceof TypeProvider) {
	    type = type.getType();

	    if (!isType(type)) {
	      throw new TypeError('TypeProvider does not return valid type');
	    }

	    return type;
	  } else if (Array.isArray(type)) {
	    if (!type.length) {
	      return ArrayType;
	    } else if (type.length === 1) {
	      return ArrayOfType(typeMap[type[0]]);
	    } else {
	      return AnyOfType.apply(void 0, toConsumableArray(type.map(function (t) {
	        return getType(typeMap[t]);
	      })));
	    }
	  } else if (isType(type)) {
	    return typeMap[type] || type;
	  }
	}
	/**
	 * Implement custom types that can be validated
	 */


	var TypeProvider =
	/*#__PURE__*/
	function () {
	  function TypeProvider() {
	    classCallCheck(this, TypeProvider);

	    if (this.__proto__ === TypeProvider.prototype) {
	      throw new Error('Cannot directly create instance of TypeProvider');
	    }
	  }
	  /**
	   * Return the type of this object
	   * @return {type}
	   */


	  createClass(TypeProvider, [{
	    key: "getType",
	    value: function getType() {
	      throw new Error('Not implemented');
	    }
	  }]);

	  return TypeProvider;
	}();

	var index = {
	  Any: AnyType,
	  AnyOf: AnyOfType,
	  Array: ArrayType,
	  ArrayOf: ArrayOfType,
	  Boolean: BooleanType,
	  Date: DateType,
	  Integer: IntegerType,
	  Number: NumberType,
	  Object: ObjectType,
	  String: StringType
	};

	varValidator.enableScope = false;
	varValidator.enableBrackets = false; // schema id counter

	var schemaCount = 0;

	var Schema =
	/*#__PURE__*/
	function (_TypeProvider) {
	  inherits(Schema, _TypeProvider);

	  createClass(Schema, null, [{
	    key: "use",

	    /**
	    Add a plugin to use with new instances of Schema. Added
	    plugins do not affect currently instanciated instances.
	     @param plugin {Function} a single function receiving the instance
	    */
	    value: function use(pluginFactory) {
	      var plugin = pluginFactory(Schema);

	      if (plugin) {
	        if (typeof plugin === 'function') {
	          Schema._plugins.push({
	            init: plugin
	          });
	        } else {
	          Schema._plugins.push(plugin);
	        }
	      }

	      return Schema;
	    }
	    /**
	    Create a new instance
	     @param fields {Object} the fields definition (will be sanitized and normalized)
	    @params options {Object} the schema options
	    */

	  }]);

	  function Schema(fields) {
	    var _this;

	    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

	    classCallCheck(this, Schema);

	    _this = possibleConstructorReturn(this, getPrototypeOf(Schema).call(this));

	    if (!fields || !Object.keys(fields).length) {
	      throw new TypeError('No defined fields');
	    } else if (_typeof_1(fields) !== 'object') {
	      throw new TypeError('Invalid fields argument');
	    }

	    Schema._plugins.forEach(function (plugin) {
	      return plugin.preInit && plugin.preInit(assertThisInitialized(_this), fields, options);
	    });

	    Object.defineProperties(assertThisInitialized(_this), {
	      options: {
	        enumerable: true,
	        configurable: false,
	        writable: false,
	        value: options
	      },
	      fields: {
	        enumerable: true,
	        configurable: false,
	        writable: false,
	        value: normalizeValidators(fields, assertThisInitialized(_this))
	      },
	      fieldNames: {
	        enumerable: true,
	        configurable: false,
	        writable: false,
	        value: Object.keys(fields)
	      },
	      _type: {
	        enumerable: false,
	        configurable: false,
	        writable: false,
	        value: createType(assertThisInitialized(_this))
	      },
	      _namedContexts: {
	        enumerable: false,
	        configurable: false,
	        writable: false,
	        value: {}
	      }
	    });

	    Schema._plugins.forEach(function (plugin) {
	      return plugin.init && plugin.init(assertThisInitialized(_this));
	    });

	    _this.fieldNames.forEach(function (field) {
	      return Object.freeze(_this.fields[field]);
	    });

	    Object.freeze(_this.fields); // no further mods!

	    Object.freeze(_this.fieldNames); //

	    return _this;
	  }
	  /**
	  Return the type for this schema
	   @return {type}
	  */


	  createClass(Schema, [{
	    key: "getType",
	    value: function getType() {
	      return this._type;
	    }
	    /**
	    Create a new empty model from the fields' default values specification
	     @return {Object}
	    */

	  }, {
	    key: "createModel",
	    value: function createModel$1(data) {
	      var _this2 = this;

	      var model = createModel(this, data);

	      Schema._plugins.forEach(function (plugin) {
	        return plugin.extendModel && plugin.extendModel(model, _this2);
	      });

	      return model;
	    }
	    /**
	    Create a new validation context based on this schema
	     @param name {String}   (optional) return a shared context identified by name
	    */

	  }, {
	    key: "createContext",
	    value: function createContext(name) {
	      var _this3 = this;

	      var newContext = !name || !this._namedContexts[name];
	      var context = newContext ? new ValidationContext(this) : this._namedContexts[name];

	      if (newContext) {
	        Schema._plugins.forEach(function (plugin) {
	          return plugin.extendContext && plugin.extendContext(context, _this3);
	        });

	        if (name) {
	          this._namedContexts[name] = context;
	        }
	      }

	      return context;
	    }
	  }]);

	  return Schema;
	}(TypeProvider); // internal properties


	Object.defineProperties(Schema, {
	  _plugins: {
	    enumerable: false,
	    configurable: false,
	    writable: false,
	    value: []
	  },
	  _normalizeField: {
	    enumerable: false,
	    configurable: false,
	    writable: false,
	    value: normalizeField
	  }
	});
	Object.defineProperties(Schema.prototype, {
	  _normalizeField: {
	    enumerable: false,
	    configurable: false,
	    writable: false,
	    value: normalizeField
	  }
	});
	/**
	Create a type for the given schema

	@param schemaType {Schema}
	@return {type}
	*/

	function createType(schemaType) {
	  return {
	    $$type: Symbol('schema' + ++schemaCount),
	    validatorFactory: function validatorFactory(fieldName, field, schema, wrappedValidator) {
	      var _field$required = field.required,
	          required = _field$required === void 0 ? false : _field$required,
	          _field$nullable = field.nullable,
	          nullable = _field$nullable === void 0 ? true : _field$nullable;
	      var validatorContext = schemaType.createContext();

	      function validator(value, options, context) {
	        if (value === undefined) {
	          return required ? 'required' : undefined;
	        } else if (value === null) {
	          return !nullable ? 'isNull' : undefined;
	        } else {
	          try {
	            if (!validatorContext.validate(value)) {
	              if (fieldName) {
	                var contextMessages = validatorContext.getMessages();
	                Object.keys(contextMessages).forEach(function (subFieldName) {
	                  return context.setMessage(fieldName + '.' + subFieldName, contextMessages[subFieldName]);
	                });
	              }

	              return 'invalid';
	            }
	          } catch (e) {
	            return 'invalidType';
	          }
	        }

	        return wrappedValidator && wrappedValidator(value, options, context);
	      }

	      validator.context = validatorContext;
	      return validator;
	    }
	  };
	}
	/**
	Sanitize all fields from the given object, make sure that each
	key is a valid name, and that each type if a recognized validator

	@param fields {object}
	@param schema {Schema}
	@return {Object}
	*/


	function normalizeValidators(fields, schema) {
	  var fieldNames = Object.keys(fields);

	  for (var _i = 0, _fieldNames = fieldNames; _i < _fieldNames.length; _i++) {
	    var fieldName = _fieldNames[_i];

	    if (!varValidator.isValid(fieldName)) {
	      throw new Error('Invalid field name : ' + fieldName);
	    }

	    var field = fields[fieldName] = normalizeField(fields[fieldName], fieldName);
	    field.validator = field.type.validatorFactory(fieldName, field, schema, field.validator);
	  }

	  return fields;
	}
	/**
	Return an object that is normalized with a valid type property

	@param field
	@param fieldName {String}   (optional) the field name
	@return {Object}
	*/


	function normalizeField(field, fieldName) {
	  if (!field) {
	    throw new TypeError('Empty field specification' + (fieldName ? ' for ' + fieldName : ''));
	  }

	  if (isType(field)) {
	    field = {
	      type: getType(field)
	    };
	  } else if (isType(field.type)) {
	    field.type = getType(field.type);
	  } else if (_typeof_1(field) === 'object') {
	    var typeSchema = new Schema(field);
	    field = {
	      type: typeSchema.getType(),
	      schema: typeSchema
	    };
	  }

	  if (!field.type || !field.type.$$type) {
	    throw new TypeError('Invalid field specification' + (fieldName ? ' for ' + fieldName : ''));
	  }

	  return field;
	}

	exports.SchemaType = index;
	exports.default = Schema;

	Object.defineProperty(exports, '__esModule', { value: true });

}));
